[![KendoReact NPM Banner](https://raw.githubusercontent.com/telerik/kendo-react/master/images/kendoreact-github-banner.png)](https://www.telerik.com/kendo-react-ui/components/free?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-listbox&utm_content=banner)

# KendoReact ListBox Component for React

> **Important**
>
> -   This package is а part of [KendoReact](https://www.telerik.com/kendo-react-ui?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-listbox)&mdash;an enterprise-grade UI library with 120+ free and premium components.
> -   This is a free React ListBox component. You can use it even in production, no sign-up or license required. If you're looking for more free React components, check out [Get Started with KendoReact Free](https://www.telerik.com/kendo-react-ui/components/free).
> -   Installing and working with this package indicates that you [accept the KendoReact License Agreement](https://www.telerik.com/purchase/license-agreement/progress-kendoreact?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-listbox).
> -   The [30-day free trial](https://www.telerik.com/try/kendo-react-ui?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-listbox) gives you access to all KendoReact components and their full functionality. Additionally, for the period of your trial, you can use our legendary technical support provided directly by the KendoReact dev team!

The [React ListBox](https://www.telerik.com/kendo-react-ui/listbox), part of KendoReact Free, enables you to display a list of items and manage the data between multiple lists.

How to start:

```sh
npm i @progress/kendo-react-listbox
```

## React ListBox

Among the features which the KendoReact ListBox component delivers are:

-   [Drag and Drop](https://www.telerik.com/kendo-react-ui/components/listbox/drag-and-drop/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-listbox)&mdash;Supports drag and drop items within the same list to reorder them or to move them between lists.
-   [Custom Items](https://www.telerik.com/kendo-react-ui/components/listbox/customization/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-listbox)&mdash;You can customize how the items of the ListBox are rendered and its toolbar button and position.
-   [Multiple List](https://www.telerik.com/kendo-react-ui/components/listbox/multiple-lists/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-listbox)&mdash; Multiple ListBox components can be connected to allow moving an item into different states.
-   [Selection](https://www.telerik.com/kendo-react-ui/components/listbox/selection/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-listbox)&mdash;You can select single on multiple item from the ListBox.
-   [Theme support](https://www.telerik.com/kendo-react-ui/components/styling/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-listbox)&mdash;The KendoReact ListBox, as well as all 100+ components in the KendoReact suite, are styled in three polished themes (Bootstrap, Material, and Default) and can be further customized to match your specific design guidelines.

How to use the ListBox component in your apps:

```tsx
import { ListBox } from '@progress/kendo-react-listbox';
...
/**
* Provide the data that you want to show in the ListBox.
* Handle the logic for user interactions within the LitsBox.
*/
<ListBox
    data={data}
    textField="Field" // Must match a field from your data source.
    /**
    * Set additional props to add a toolbar and handle user interactions.
    */
/>
```

## Support Options

For any issues you might encounter while working with the KendoReact ListBox, use any of the available support channels:

-   Industry-leading technical support&mdash;KendoReact paid license holders and users with an active (free) trial license can take advantage of our outstanding customer support. To submit a ticket, use [the dedicated KendoReact support system](https://www.telerik.com/account/support-center/contact-us/technical-support?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-listview).
-   Product forums&mdash;The [KendoReact forums](https://www.telerik.com/forums/kendo-ui-react?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-listview) are part of the free support you can get from the community and from the KendoReact team.
-   Feedback portal&mdash;The [KendoReact feedback portal](https://feedback.telerik.com/kendo-react-ui?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-listbox) is where you can request and vote for new features to be added.

## Resources

-   [Getting Started with KendoReact](https://www.telerik.com/kendo-react-ui/components/getting-started/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-listbox)
-   [Get Started with KendoReact Free](https://www.telerik.com/kendo-react-ui/components/free)
-   [Get Started with the KendoReact ListBox](https://www.telerik.com/kendo-react-ui/components/listbox/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-listbox)
-   [API Reference of the KendoReact ListBox](https://www.telerik.com/kendo-react-ui/components/listbox/api/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-listbox)
-   [KendoReact Roadmap](https://www.telerik.com/support/whats-new/kendo-react-ui/roadmap?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-listbox)
-   [Blogs](https://www.telerik.com/blogs/tag/kendoreact?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-listbox)
-   [Demos, documentation, and component reference](https://www.telerik.com/kendo-react-ui/components/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-listbox)
-   [KendoReact pricing and licensing](https://www.telerik.com/kendo-react-ui/pricing?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-listbox)
-   [Changelog](https://www.telerik.com/kendo-react-ui/components/changelogs/ui-for-react/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-listbox)

High-level component overview page:

-   [React ListBox Component](https://www.telerik.com/kendo-react-ui/listbox)

_Copyright © 2025 Progress Software Corporation and/or its subsidiaries or affiliates. All Rights Reserved._

_Progress, Telerik, and certain product names used herein are trademarks or registered trademarks of Progress Software Corporation and/or one of its subsidiaries or affiliates in the U.S. and/or other countries._
